UVA 12124 UVAlive 3971 Assemble(二分 + 贪心)

Problem A - Assemble

Time limit: 2 seconds

Recently your team noticed that the computer you use to practice for programming contests is not good enough anymore. Therefore, you decide to buy a new computer.

To make the ideal computer for your needs, you decide to buy separate components and assemble the computer yourself. You need to buy exactly one of each type of component.

The problem is which components to buy. As you all know, the quality of a computer is equal to the quality of its weakest component. Therefore, you want to maximize the quality of the component with the lowest quality, while not exceeding your budget.

Input

On the first line one positive number: the number of testcases, at most 100. After that per testcase:

  • One line with two integers: 1 ≤ n ≤ 1000, the number of available components and 1 ≤ b ≤ 1000000000, your budget.
  • n lines in the following format: ``type name price quality'', where type is a string with the type of the component,name is a string with the unique name of the component, price is an integer (0 ≤ price < 1000000) which represents the price of the component and quality is an integer (0 ≤ quality ≤ 1000000000) which represents the quality of the component (higher is better). The strings contain only letters, digits and underscores and have a maximal length of 20 characters.

It will always possible to construct a computer with your budget.

Output

Per testcase:

  • One line with one integer: the maximal possible quality.

Sample Input

1
18 800
processor 3500_MHz 66 5
processor 4200_MHz 103 7
processor 5000_MHz 156 9
processor 6000_MHz 219 12
memory 1_GB 35 3
memory 2_GB 88 6
memory 4_GB 170 12
mainbord all_onboard 52 10
harddisk 250_GB 54 10
harddisk 500_FB 99 12
casing midi 36 10
monitor 17_inch 157 5
monitor 19_inch 175 7
monitor 20_inch 210 9
monitor 22_inch 293 12
mouse cordless_optical 18 12
mouse microsoft 30 9
keyboard office 4 10

Sample Output

9

题意:有一定的钱,有一些“电脑配件”,要求在钱数内每种配件用一次,组装出性能最高的电脑,电脑的性能为所有配件中质量最小的。求出性能。

思路:二分 + 贪心。。从0-最大质量之间找一个质量,然后利用贪心,尽量拿钱数最小的去组合。如果能组合出来。说明最优解在右边,如果不能,说明最优解在左边,直到区间趋近为止。

代码:

#include <stdio.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <map>
using namespace std;

int t, n, v, num;
int end, start;
int sba, sbb;
int pnum[1005];
char name[25];
struct Pe {
    int v, q;
} p[1005][1005];
map<string, int> vis;

int cmp(Pe a, Pe b) {
    return a.v < b.v;
}
int judge(int mid) {
    int sum = 0, i, j;
    for (i = 1; i < num; i ++) {
	for (j = 0; j < pnum[i]; j ++) {
	    if (p[i][j].q >= mid && sum + p[i][j].v <= v) {
		sum += p[i][j].v;
		break;
	    }
	}
	if (j == pnum[i])
	    return 0;
    }
    return 1;
}
int main() {
    scanf("%d", &t);
    while (t --) {
	vis.clear();
	memset(pnum, 0, sizeof(pnum));
	memset(p, 0, sizeof(p));
	num = 1;
	start = 0; end = 0;
	scanf("%d%d\n", &n, &v);
	for (int i = 0; i < n; i ++) {
	    scanf("%s%*s%d%d", name, &sba, &sbb);
	    if (end < sbb)
		end = sbb;
	    if (!vis[name]) {
		vis[name] = num ++;
		p[vis[name]][pnum[vis[name]]].v = sba;
		p[vis[name]][pnum[vis[name]] ++].q = sbb;
	    }
	    else {
		p[vis[name]][pnum[vis[name]]].v = sba;
		p[vis[name]][pnum[vis[name]] ++].q = sbb;
	    }
	}
	for (int i = 1; i < num; i ++) {
	    sort(p[i], p[i] + pnum[i], cmp);
	}
	int mid;
	while (start < end) {
	    mid = (start + end) / 2;
	    if (judge(mid)) {
		if (start == mid)
		    break;
		start = mid;
	    }
	    else
		end = mid;
	}
	if (judge(mid + 1))
	    mid ++;
	printf("%d\n", mid);
    }
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值